commit 322ae953e144d9e1fdc06d993d2e4551f5fb1322
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Thu Dec 21 23:33:10 2023 +0000

    tweak observability

diff --git a/src/src/functions.h b/src/src/functions.h
index b201467b2..ef84e3d7c 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -1400,6 +1400,11 @@ HDEBUG(D_transport|D_acl|D_v) debug_printf_indent("  SMTP%c> %s\n",
     client_cmd_log = string_catn(client_cmd_log, US"|", 1); 
     (void) string_from_gstring(client_cmd_log);
     }
+  else if (mode == SCMD_MORE)
+    {
+    client_cmd_log = string_catn(client_cmd_log, US"+", 1);
+    (void) string_from_gstring(client_cmd_log);
+    }
   store_pool = old_pool;
   }
 #  endif
diff --git a/src/src/smtp_out.c b/src/src/smtp_out.c
index 90a0eb23e..62557072e 100644
--- a/src/src/smtp_out.c
+++ b/src/src/smtp_out.c
@@ -649,7 +649,7 @@ Arguments:
   sx	     SMTP connection, contains buffer for pipelining, and socket
   mode       buffer, write-with-more-likely, write
   format     a format, starting with one of
-             of HELO, MAIL FROM, RCPT TO, DATA, ".", or QUIT.
+             of HELO, MAIL FROM, RCPT TO, DATA, BDAT, ".", or QUIT.
 	     If NULL, flush pipeline buffer only.
   ...        data for the format
 
diff --git a/src/src/transport.c b/src/src/transport.c
index a0f097579..79a69f941 100644
--- a/src/src/transport.c
+++ b/src/src/transport.c
@@ -1658,6 +1658,10 @@ another message waiting for the same host. However, it doesn't do this if the
 current continue sequence is greater than the maximum supplied as an argument,
 or greater than the global connection_max_messages, which, if set, overrides.
 
+It is also called if conditions are otherwise right for pipelining a QUIT after
+the message data, since if there is another message waiting we do not want to
+send that QUIT.
+
 Arguments:
   transport_name     name of the transport
   hostname           name of the host

